

import java.util.Scanner;

/**
 * Created by leon on 2/9/18.
 */
public class Console {
    
    public Console() {
        Console.println("Welcome to the Scientific Calculator update 4.2");
             
        Scanner in = new Scanner(System.in);
        String response = "";
        while(!response.equalsIgnoreCase("quit")) {            
            Double x = Console.getDoubleInput("Enter a number.");
            String operation = Console.getStringInput("Enter an operation");
            Double y = Console.getDoubleInput("Enter a number.");
            CoreCalculations cc = new CoreCalculations(x, y);
            ScientificCalculations sc = new ScientificCalculations(x);
            LogarithmicCalculations lc = new LogarithmicCalculations(x);
            
            switch(operation) {
                case "+":
                    double sum = cc.add();
                    System.out.println(x + " + " + y + " = " + sum);
                    break;
                
                case "-":
                    double difference = cc.subtract();
                    System.out.println(x + " - " + y + " = " + difference);
                    break;
                
                case "*":
                    double product = cc.multiply();
                    System.out.println(x + " * " + y + " = " + product);
                    break;
                
                case "/":
                    Double quotient = cc.divide();
                    if(quotient.isInfinite()) {
                        System.out.println(x + " / " + y + " = " + "Err");
                    } else {
                        System.out.println(x + " / " + y + " = " + quotient);
                    }
                    break;
                    
                case "√":
                    System.out.println("√" + x + " = " + cc.squareRoot());
                    break;
                    
                case "^2":
                    System.out.println(x + "^2 = " + cc.square());
                    break;
                    
                case "^3":
                    System.out.println(x + "^3 = " + cc.cube());
                    break;
                    
                case "^x":
                    System.out.println(x + "^x = " + cc.exponentiation());
                    break;
                    
                case "1/x":
                    System.out.println("1/x = " + cc.inverse());
                    break;
                    
                case "abs":
                    System.out.println("abs(" + x + ") = " + cc.absoluteValue());
                    break;
                    
                case "invert":
                    System.out.println("invert(" + x + ") = " + cc.switchSign());
                    break;
                    
                case "sin":
                    System.out.println("sin(" + x + ") = " + sc.sine());
                    break;
                    
                case "arcsin":
                    System.out.println("sin-1(" + x + ") = " + sc.inverseSine());
                    break;
                    
                case "cosin":
                    System.out.println("cos(" + x + ") = " + sc.cosine());
                    break;
                    
                case "arccos":
                    System.out.println("cos-1(" + x + ") = " + sc.inverseCosine());
                    break;
                    
                case "tan":
                    System.out.println("tan(" + x + ") = " + sc.tangent());
                    break;
                    
                case "arctan":
                    System.out.println("tan-1(" + x + ") = " + sc.inverseTangent());
                    break;
                    
                case "fact":
                    System.out.println("fact(" + x + ") = " + sc.factorial());
                    break;
                    
                case "log":
                    System.out.println("log(" + x + ") = " + lc.log());
                    break;
                    
                case "log10":
                    System.out.println("log10(" + x + ") = " + lc.log10());
                    break;
                    
                default:
                    System.out.println("You did not enter a correct operation.");
            }
            System.out.println("continue or quit");
            response = in.nextLine();
        }                
    }
    
    public double clearDisplay() {
        return 0.0;
    }

    public static void print(String output, Object... args) {
        System.out.printf(output, args);
    }

    public static void println(String output, Object... args) {
        print(output + "\n", args);
    }

    public static String getStringInput(String prompt) {
        Scanner scanner = new Scanner(System.in);
        println(prompt);
        String userInput = scanner.nextLine();
        return userInput;
    }

    public static Integer getIntegerInput(String prompt) {
        Scanner scanner = new Scanner(System.in);
        println(prompt);
        int userInput = scanner.nextInt();
        return userInput;
    }

    public static Double getDoubleInput(String prompt) {
        Scanner scanner = new Scanner(System.in);
        println(prompt);
        double userInput = scanner.nextDouble();
        return userInput;
    }
}
